## net.sf.saxon.expr
Class PromotionOffer

    java.lang.Object
      |
      +--net.sf.saxon.expr.PromotionOffer

public class PromotionOffer
extends java.lang.Object

PromotionOffer is an object used transiently during compilation of an expression. It contains information passed by a containing expression to its subexpressions, when looking for subexpressions that can be promoted to a higher level because they are not dependent on the context established by the containing expression. The object is also used to pass back return information when the promotion actually takes place.

Field Summary
`int` `action` action is one of the possible promotion actions, FOCUS_INDEPENDENT, RANGE_INDEPENDENT, INLINE_VARIABLE_REFERENCES, ANY_ORDER, ANY_ORDER_UNIQUE
`Binding` `binding` In the case of RANGE_INDEPENDENT, "binding" identifies the range variable whose dependencies we are looking for
`Expression` `containingExpression` When a promotion offer is made, containingExpression identifies the level to which the promotion should occur.
`static int` `FOCUS_INDEPENDENT` FOCUS_INDEPENDENT requests promotion of all non-trivial subexpressions that don't depend on the focus.
`static int` `INLINE_VARIABLE_REFERENCES` Inline variable references causes all references to a variable V to be replaced by the expression E.
`boolean` `mustEliminateDuplicates` In the case of UNORDERED, "mustEliminateDuplicates" is a boolean that is set to true if the nodes can be delivered in any order so long as there are no duplicates (for example, as required by the count() function).
`boolean` `promoteDocumentDependent` In the case of FOCUS_INDEPENDENT, "promoteDocumentDependent" is a boolean that, when set to true, indicates that it is safe to promote a subexpression that depends on the context document but not on other aspects of the focus.
`static int` `RANGE_INDEPENDENT` RANGE_INDEPENDENT requests promotion of all non-trivial subexpressions that don't depend on a specified range variable.
`static int` `UNORDERED` UNORDERED indicates that the containing expression does not require the results to be delivered in any particular order.

Constructor Summary
`PromotionOffer()`

Method Summary
`Expression` `accept(Expression child)` Method to test whether a subexpression qualifies for promotion, and if so, to accept the promotion.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### FOCUS_INDEPENDENT

    public static final int FOCUS_INDEPENDENT

  FOCUS_INDEPENDENT requests promotion of all non-trivial subexpressions that don't depend on the focus. This is typically used to extract subexpressions from a filter predicate. The offer is optional - each subexpression can decide whether it's worth the trouble of promoting itself. The offer is normally passed on to subexpressions, except subexpressions that are evaluated with a different focus

  See Also:
    Constant Field Values

### RANGE_INDEPENDENT

    public static final int RANGE_INDEPENDENT

  RANGE_INDEPENDENT requests promotion of all non-trivial subexpressions that don't depend on a specified range variable. This is typically used to extract subexpressions from the action of a for expression or the condition of a some/every quantified expression. The offer is optional - each subexpression can decide whether it's worth the trouble of promoting itself. The offer is normally passed on to subexpressions, except subexpressions that are evaluated with a different focus or a different range variable, because these may have other dependencies that prevent their promotion.

  See Also:
    Constant Field Values

### INLINE_VARIABLE_REFERENCES

    public static final int INLINE_VARIABLE_REFERENCES

  Inline variable references causes all references to a variable V to be replaced by the expression E. The variable is supplied in the "binding" property; the replacement expression in the containingExpression property

  See Also:
    Constant Field Values

### UNORDERED

    public static final int UNORDERED

  UNORDERED indicates that the containing expression does not require the results to be delivered in any particular order. The boolean mustEliminateDuplicates is set if duplicate items in the result are not allowed.

  See Also:
    Constant Field Values

### action

    public int action

  action is one of the possible promotion actions, FOCUS_INDEPENDENT, RANGE_INDEPENDENT, INLINE_VARIABLE_REFERENCES, ANY_ORDER, ANY_ORDER_UNIQUE

### promoteDocumentDependent

    public boolean promoteDocumentDependent

  In the case of FOCUS_INDEPENDENT, "promoteDocumentDependent" is a boolean that, when set to true, indicates that it is safe to promote a subexpression that depends on the context document but not on other aspects of the focus. This is the case, for example, in a filter expression when it is known that all the nodes selected by the expression will be in the same document - as happens when the filter is applied to a path expression. This allows subexpressions such as key() to be promoted

### mustEliminateDuplicates

    public boolean mustEliminateDuplicates

  In the case of UNORDERED, "mustEliminateDuplicates" is a boolean that is set to true if the nodes can be delivered in any order so long as there are no duplicates (for example, as required by the count() function). If this boolean is false, the nodes can be delivered in any order and duplicates are allowed (for example, as required by the boolean() function).

### binding

    public Binding binding

  In the case of RANGE_INDEPENDENT, "binding" identifies the range variable whose dependencies we are looking for

### containingExpression

    public Expression containingExpression

  When a promotion offer is made, containingExpression identifies the level to which the promotion should occur. When a subexpression is promoted, an expression of the form let $VAR := SUB return ORIG is created, and this replaces the original containingExpression within the PromotionOffer.

Constructor Detail

### PromotionOffer

    public PromotionOffer()

Method Detail

### accept

    public Expression accept(Expression child)
                      throws XPathException

  Method to test whether a subexpression qualifies for promotion, and if so, to accept the promotion.

  Returns:
    if promotion was done, returns the expression that should be used in place of the child expression. If no promotion was done, returns null.
    `XPathException`